From oracle-l-bounce@freelists.org  Mon Dec 13 09:20:13 2004
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air189.startdedicated.com (root@localhost)
 by orafaq.com (8.11.6/8.11.6) with ESMTP id iBDFKDV29869
 for <oracle-l@orafaq.com>; Mon, 13 Dec 2004 09:20:13 -0600
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air189.startdedicated.com (8.11.6/8.11.6) with ESMTP id iBDFKC029862
 for <oracle-l@orafaq.com>; Mon, 13 Dec 2004 09:20:12 -0600
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 9650172CBFF;
 Mon, 13 Dec 2004 10:26:37 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 20708-86; Mon, 13 Dec 2004 10:26:37 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 205AC72C311;
 Mon, 13 Dec 2004 10:23:58 -0500 (EST)
X-MimeOLE: Produced By Microsoft Exchange V6.5.7226.0
Content-class: urn:content-classes:message
MIME-Version: 1.0
Content-type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 8bit
Subject: RE: Direct I/O questions
Date: Mon, 13 Dec 2004 16:19:01 +0100
Message-ID: <BFCF159FFD14F444B205968F32DBD5BB6A541B@MAILEX01.rasgroup.ita.localnet>
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
Thread-Topic: Direct I/O questions
Thread-Index: AcTdX/gx5MWoxgqeTLGSq4Xl3QWJlAACKf+wAO8EPDA=
From: "Magni Fabrizio" <Fabrizio.Magni@rasnet.it>
To: <james.p.kramer@unisys.com>, <oracle-l@freelists.org>
X-OriginalArrivalTime: 13 Dec 2004 15:18:58.0387 (UTC) FILETIME=[11536A30:01C4E127]
X-archive-position: 13547
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: Fabrizio.Magni@rasnet.it
Precedence: normal
Reply-To: Fabrizio.Magni@rasnet.it
X-list: oracle-l
X-Virus-Scanned: by amavisd-new at freelists.org

Hello James,
eventually I was able to make O_DIRECT work even on x86_64 (kernel
2.6.5-7.97-smp and 2.6.9 vanilla).
Unfortunately I haven't got any itanium where to test it.

I had to create a file named xxx in the same directory of the executable
with:

dd if=3D/dev/zero of=3Dxxx bs=3D4196 count=3D100

I tested on ext2, ext3, reiserfs.

Regards
Fabrizio

The code (Thanks to Andrea Arcangeli for the revision):

#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>

#define O_DIRECT         040000 /* direct disk access hint */


int main(int argc, char *argv[])
{

     int fd =3D open("xxx", O_RDWR|O_DIRECT);
     int len, pagesize =3D getpagesize();
     char *message;

        printf("Pagesize: %d\n", pagesize);

     posix_memalign((void **)&message, pagesize, pagesize);
     memset(message, 0xff, pagesize);
     printf("%p\n", message);
     if(fd < 0) {
         printf("Unable to open file, errno is %d.\n", errno);
     } else {
         if((len =3D read(fd, message, pagesize)) < 0) {
            perror("read");
          } else {
            printf("%d bytes read from file.\n", len);
            printf("Message: %s", message);
          }
    }
    close(fd);

    return 0;
}

--
http://www.freelists.org/webpage/oracle-l

